-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

  -- this relates to the colours used in the editor

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

function mc(integer code) -- using a code, construct palette colours
    sequence s
    integer r,g,b
    s = sprintf("%d", code)
    r = s[1] - '0'
    g = s[2] - '0'
    b = s[3] - '0'
    s = {0,85,127,191,255}
    r = s[r]
    g = s[g]
    b = s[b]
    return rgb(r,g,b)
end function

global constant mainwindowbackcolour = getSysColor(COLOR_BTNFACE)

function makePALETTE()
    sequence s

    s =
        {111,222,333,444,555,
        355,133,131,253,443,
        415,324,313,551,554,
        115,234,113,531,544,
        542,432,321,511,515}

    for i = 1 to length(s) do
        s[i] = mc(s[i])
    end for

    return s
end function

global constant PALETTE = makePALETTE()

-- win32lib colours:
--      {Black, Blue, Green, Cyan,
--      Red, Magenta, Brown,White,
--      mainwindowbackcolour, BrightBlue, BrightGreen, BrightCyan,
--      BrightRed, BrightMagenta, Yellow, BrightWhite }


sequence colourindex

global constant
    COLOURSPACE = -1,
    COLOURHILITE = 0, -- must always be 0 to be easily distinguishable from 'proper' colours

    COLOURKEYWORD = 1,
    COLOURBUILTIN = 2,
    COLOUROTHER = 3,
    COLOURSYMBOL = 4,
    COLOURBRACE = 5,
    COLOURSTRING = 6,
    COLOURCOMMENT = 7,
    COLOURWIN32LIB = 8, -- win32lib global routines and functions PL 27/10/02
    COLOURGLOCALS = 9,   -- local global routines and functions PL 27/10/02

    COLOURBACKGROUND = 10,
    FOREGROUNDHILITE = 11,
    BACKGROUNDHILITE = 12,
    COLOURCURSOR = 13,

    COLOURTOP = COLOURGLOCALS -- If any more colours are added then this line gets adj. too


global procedure resetColourIndex()
    colourindex = repeat(0, COLOURCURSOR)
    colourindex[COLOURKEYWORD] = 14--11
    colourindex[COLOURBUILTIN] = 14--16
    colourindex[COLOUROTHER] = 6
    colourindex[COLOURSYMBOL] = 9--15
    colourindex[COLOURBRACE] = 21--14
    colourindex[COLOURSTRING] = 4
    colourindex[COLOURCOMMENT] = 25--5
    colourindex[COLOURWIN32LIB] = 11
    colourindex[COLOURGLOCALS] = 22
    colourindex[COLOURBACKGROUND] = 1
    colourindex[FOREGROUNDHILITE] = 5--14
    colourindex[BACKGROUNDHILITE] = 16
    colourindex[COLOURCURSOR] = 5--1
end procedure


global function getColourIndexForOptions()
    return colourindex[COLOURKEYWORD .. COLOURCURSOR]
end function

global procedure setColourIndexFromOptions(sequence newindex)
    colourindex[COLOURKEYWORD .. COLOURCURSOR] = newindex
end procedure

procedure initializeColours()

    -- define colour requirements for the ini file
    defineIniGroup("My Colours")
    defineIniHeading("keyword", INT)
    defineIniHeading("builtin", INT)
    defineIniHeading("other", INT)
    defineIniHeading("symbol", INT)
    defineIniHeading("brace", INT)
    defineIniHeading("string", INT)
    defineIniHeading("comment", INT)
    defineIniHeading("win32lib", INT)
    defineIniHeading("glocals", INT)
    defineIniHeading("Background", INT)
    defineIniHeading("highlighttext", INT)
    defineIniHeading("highlightback", INT)
    defineIniHeading("cursor colour", INT)


    resetColourIndex()
    colourindex[COLOURKEYWORD] = getIniValue("keyword", colourindex[COLOURKEYWORD] )
    colourindex[COLOURBUILTIN] = getIniValue("builtin", colourindex[COLOURBUILTIN] )
    colourindex[COLOUROTHER] = getIniValue("other", colourindex[COLOUROTHER] )
    colourindex[COLOURSYMBOL] = getIniValue("symbol", colourindex[COLOURSYMBOL] )
    colourindex[COLOURBRACE] = getIniValue("brace", colourindex[COLOURBRACE] )
    colourindex[COLOURSTRING] = getIniValue("string", colourindex[COLOURSTRING] )
    colourindex[COLOURCOMMENT] = getIniValue("comment", colourindex[COLOURCOMMENT] )
    colourindex[COLOURWIN32LIB] = getIniValue("win32lib", colourindex[COLOURWIN32LIB] )
    colourindex[COLOURGLOCALS] = getIniValue("glocals", colourindex[COLOURGLOCALS] )
    colourindex[COLOURBACKGROUND] = getIniValue("Background", colourindex[COLOURBACKGROUND])
    colourindex[FOREGROUNDHILITE] = getIniValue("highlighttext", colourindex[FOREGROUNDHILITE])
    colourindex[BACKGROUNDHILITE] = getIniValue("highlightback", colourindex[BACKGROUNDHILITE])
    colourindex[COLOURCURSOR] = getIniValue("cursor colour", colourindex[COLOURCURSOR])

end procedure

initializeColours()

global procedure storeColoursToIni()

    switchToIniGroup("My Colours")
    setIniValue("keyword", colourindex[COLOURKEYWORD] )
    setIniValue("builtin", colourindex[COLOURBUILTIN] )
    setIniValue("other", colourindex[COLOUROTHER] )
    setIniValue("symbol", colourindex[COLOURSYMBOL] )
    setIniValue("brace", colourindex[COLOURBRACE] )
    setIniValue("string", colourindex[COLOURSTRING] )
    setIniValue("comment", colourindex[COLOURCOMMENT] )
    setIniValue("win32lib", colourindex[COLOURWIN32LIB] )
    setIniValue("glocals", colourindex[COLOURGLOCALS] )
    setIniValue("Background", colourindex[COLOURBACKGROUND] )
    setIniValue("highlighttext", colourindex[FOREGROUNDHILITE])
    setIniValue("highlightback", colourindex[BACKGROUNDHILITE])
    setIniValue("cursor colour", colourindex[COLOURCURSOR])

end procedure


------------------ routines to enable error highlighting (ie, in different colour to usual)	
global function getColour(integer index)
    return PALETTE[colourindex[index]]
end function
global function getColourIndex(integer index)
    return colourindex[index]
end function
global procedure setColourIndex(integer index, integer indici)
    colourindex[index] = indici
end procedure
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------