--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

global function extractPathAndName(sequence pathname)
-- extract path & name information from complete pathname
    sequence path, name
    integer len, pos

    len = length(pathname)
    pos = 0

    for i = len to 1 by -1 do
        if pathname[i] = '\\' then -- delimiter found, must always exist
            pos = i
            exit
        end if
    end for

    path = pathname[1..pos]
    name = pathname[pos+1..len]

    return {path, name}
end function

--------------------------------------------------------------------------------
global function extractNameAndExtn(sequence filename)
    sequence name, extn

    name = filename
    extn = ""

    for i=length(filename) to 1 by -1 do
        if filename[i] = '.' then
            name = filename[1 .. i-1]
            extn = filename[i + 1 .. length(filename)]
            exit
        end if
    end for

    return { name, extn }
end function
---------------------------------------------------------------------------------
