
-- code to manage the selection processes

integer anchorline, anchorcol, dragline, dragcol

procedure updatemenu()

--
-- call whenever dragline is altered
--
atom tf
    -- cut & copy
    -- comment/uncomment/inc indent/dec indent
    if dragline=0 then
        tf=w32False
    else
        if anchorline=0 then
            tf = message_box(
                "Internal error with selected text (cancelled)",
                "Internal Error!",MB_OK)
            dragline=0 dragcol=0
        end if
        tf=w32True
    end if
    setEnable(EditCut, tf)
    setEnable(EditCuta, tf)
    setEnable(EditCopy, tf)
    setEnable(EditCopa, tf)
    if dragline!=anchorline then
        tf=w32False
    end if
    setEnable(EditFfsl, tf)
    setEnable(EditFnsl, tf)
end procedure

procedure setAnchorDragAll_local(integer a_line, integer a_col, integer d_line, integer d_col)
    anchorline = a_line
    anchorcol = a_col
    dragline =  d_line
    updatemenu()
    dragcol = d_col
end procedure

global procedure resetSelection()
    setAnchorDragAll_local(0,0,0,0)
end procedure

resetSelection()

global function isTextSelected()
    if dragline = 0 then
        return w32False
    end if
    return w32True
end function

global function getSelectTop()
    if anchorline > dragline then
        return dragline
    end if
    return anchorline
end function

global function getSelectLeft()
    if anchorline > dragline then
        return dragcol
    elsif anchorline = dragline then
        if anchorcol > dragcol then return
            dragcol
        end if
    end if
    return anchorcol
end function

global function getSelectBottom()
    if anchorline > dragline then
        return anchorline
    end if
    return dragline
end function

global function getSelectRight()
    if anchorline > dragline then
        return anchorcol - 1
    elsif anchorline = dragline then
        if anchorcol > dragcol then
            return anchorcol - 1
        end if
    end if
    return dragcol - 1
end function

global procedure setAnchorDragAll( sequence s)
    setAnchorDragAll_local( s[1], s[2], s[3], s[4] )
end procedure

global function getAnchorDragAll()
    if not isTextSelected() then
        resetSelection()
    end if
    return { anchorline, anchorcol, dragline, dragcol }
end function

global procedure setAnchor(integer line, integer col)
    setAnchorDragAll_local( line, col, 0, 0 )
end procedure

global procedure setSelectAll(integer top, integer left, integer bottom, integer right)
    setAnchorDragAll_local( top, left, bottom, right + 1 )
end procedure

global function extendSelection(integer drag_line, integer drag_col)
-- update select vars and work out the lines that need repainting

    sequence range

    -- exit if no movement has occurred
    if drag_line = anchorline and drag_col = anchorcol and dragline = 0 then
        return {0, 0}
    end if

-------------------------------------------------------------
    -- if drag is leftward then ensure that first anchored char gets included
    if dragline = 0 then -- first drag since anchor established
        -- set drag line/col
        dragline = anchorline
        updatemenu()
        dragcol = anchorcol
    end if
-------------------------------------------------------------

    -- determine lines to be repainted
    if drag_line > dragline then -- drag going down
        range = { dragline, drag_line }
    else -- drag going up or at least on same line
        range = { drag_line, dragline }
    end if

    -- update variables
    dragcol = drag_col
    dragline = drag_line
    updatemenu()

    return range

end function